searchNodes=[{"doc":"Ergo contains the helper function parse/2 otherwise see Ergo.Terminals , Ergo.Combinators and Ergo.Parsers for the individual parsers.","ref":"Ergo.html","title":"Ergo","type":"module"},{"doc":"The parser/2 function is a simple entry point to parsing inputs that constructs the Context record required. Options debug: [true | false] Examples iex&gt; alias Ergo.Terminals iex&gt; parser = Terminals . literal ( &quot;Hello&quot; ) iex&gt; Ergo . parse ( parser , &quot;Hello World&quot; ) % Ergo.Context { status : :ok , ast : &quot;Hello&quot; , char : ?o , input : &quot; World&quot; , index : 5 , line : 1 , col : 6 }","ref":"Ergo.html#parse/3","title":"Ergo.parse/3","type":"function"},{"doc":"Ergo.Combinators is the key set of parsers used for combining together other parsers. Parsers choice sequence many optional ignore transform lookeahead not_lookahead","ref":"Ergo.Combinators.html","title":"Ergo.Combinators","type":"module"},{"doc":"The choice/1 parser takes a list of parsers. It tries each in order attempting to match one. Once a match has been made choice returns the result of the matching parser. Examples iex&gt; alias Ergo.Context iex&gt; import Ergo . { Terminals , Combinators } iex&gt; parser = choice ( [ literal ( &quot;Foo&quot; ) , literal ( &quot;Bar&quot; ) , literal ( &quot;Hello&quot; ) , literal ( &quot;World&quot; ) ] , label : &quot;Foo|Bar|Hello|World&quot; ) iex&gt; context = Ergo . parse ( parser , &quot;Hello World&quot; ) iex&gt; assert % Context { status : :ok , ast : &quot;Hello&quot; , input : &quot; World&quot; , char : ?o , index : 5 , col : 6 } = context iex&gt; alias Ergo.Context iex&gt; import Ergo . { Terminals , Combinators } iex&gt; parser = choice ( [ literal ( &quot;Foo&quot; ) , literal ( &quot;Bar&quot; ) ] ) iex&gt; context = Ergo . parse ( parser , &quot;Hello World&quot; ) iex&gt; % Context { status : { :error , :no_valid_choice } , message : &quot;No valid choice&quot; , ast : nil , input : &quot;Hello World&quot; } = context","ref":"Ergo.Combinators.html#choice/2","title":"Ergo.Combinators.choice/2","type":"function"},{"doc":"The ignore/1 parser matches but ignores the AST of its child parser. Examples iex&gt; alias Ergo.Context iex&gt; import Ergo . { Terminals , Combinators } iex&gt; parser = sequence ( [ literal ( &quot;Hello&quot; ) , ignore ( ws ( ) ) , literal ( &quot;World&quot; ) ] ) iex&gt; context = Ergo . parse ( parser , &quot;Hello World&quot; ) iex&gt; assert % Context { status : :ok , ast : [ &quot;Hello&quot; , &quot;World&quot; ] , index : 11 , col : 12 , char : ?d } = context","ref":"Ergo.Combinators.html#ignore/2","title":"Ergo.Combinators.ignore/2","type":"function"},{"doc":"The lookahead parser accepts a parser and matches it but does not update the context when it succeeds. Example iex&gt; alias Ergo.Context iex&gt; import Ergo . { Combinators , Terminals } iex&gt; parser = lookahead ( literal ( &quot;Hello&quot; ) ) iex&gt; Ergo . parse ( parser , &quot;Hello World&quot; ) % Context { status : :ok , ast : nil , input : &quot;Hello World&quot; , char : 0 , index : 0 , line : 1 , col : 1 } iex&gt; alias Ergo.Context iex&gt; import Ergo . { Combinators , Terminals } iex&gt; parser = lookahead ( literal ( &quot;Helga&quot; ) ) iex&gt; Ergo . parse ( parser , &quot;Hello World&quot; ) % Context { status : { :error , :lookahead_fail } , ast : [ ?l , ?e , ?H ] , char : ?l , index : 3 , col : 4 , input : &quot;lo World&quot; }","ref":"Ergo.Combinators.html#lookahead/2","title":"Ergo.Combinators.lookahead/2","type":"function"},{"doc":"Examples iex&gt; Logger . disable ( self ( ) ) iex&gt; alias Ergo.Context iex&gt; import Ergo . { Combinators , Terminals } iex&gt; parser = many ( wc ( ) , label : &quot;Chars&quot; ) iex&gt; context = Ergo . parse ( parser , &quot;Hello World&quot; , debug : true ) iex&gt; assert % Context { status : :ok , debug : true , ast : [ ?H , ?e , ?l , ?l , ?o ] , input : &quot; World&quot; , index : 5 , col : 6 , char : ?o } = context iex&gt; alias Ergo.Context iex&gt; import Ergo . { Combinators , Terminals } iex&gt; parser = many ( wc ( ) , min : 6 ) iex&gt; context = Ergo . parse ( parser , &quot;Hello World&quot; ) iex&gt; assert % Context { status : { :error , :many_less_than_min } , ast : nil , input : &quot; World&quot; , char : ?o , index : 5 , col : 6 } = context iex&gt; alias Ergo . { Context , Parser } iex&gt; import Ergo . { Combinators , Terminals } iex&gt; parser = many ( wc ( ) , max : 3 ) iex&gt; context = Ergo . parse ( parser , &quot;Hello World&quot; ) iex&gt; assert % Context { status : :ok , ast : [ ?H , ?e , ?l ] , input : &quot;lo World&quot; , char : ?l , index : 3 , col : 4 } = context iex&gt; alias Ergo . { Context , Parser } iex&gt; import Ergo . { Combinators , Terminals } iex&gt; parser = many ( wc ( ) , map : &amp; Enum . count / 1 ) iex&gt; context = Ergo . parse ( parser , &quot;Hello World&quot; ) iex&gt; % Context { status : :ok , ast : 5 , input : &quot; World&quot; , index : 5 , col : 6 , char : ?o } = context","ref":"Ergo.Combinators.html#many/2","title":"Ergo.Combinators.many/2","type":"function"},{"doc":"The not_lookahead parser accepts a parser and attempts to match it. If the match fails the not_lookahead parser returns status: :ok but does not affect the context otherwise. If the match succeeds the not_lookahead parser fails with {:error, :lookahead_fail} Examples iex&gt; alias Ergo.Context iex&gt; import Ergo.{Combinators, Terminals} iex&gt; parser = not_lookahead(literal(&quot;Foo&quot;)) iex&gt; Ergo.parse(parser, &quot;Hello World&quot;) %Context{status: :ok, input: &quot;Hello World&quot;} iex&gt; alias Ergo.{Context, Parser} iex&gt; import Ergo.{Combinators, Terminals} iex&gt; parser = not_lookahead(literal(&quot;Hello&quot;)) iex&gt; Ergo.parse(parser, &quot;Hello World&quot;) %Context{status: {:error, :lookahead_fail}, input: &quot;Hello World&quot;}","ref":"Ergo.Combinators.html#not_lookahead/2","title":"Ergo.Combinators.not_lookahead/2","type":"function"},{"doc":"Examples iex&gt; alias Ergo.Context iex&gt; import Ergo . { Terminals , Combinators } iex&gt; context = Ergo . parse ( optional ( literal ( &quot;Hello&quot; ) ) , &quot;Hello World&quot; ) iex&gt; assert % Context { status : :ok , ast : &quot;Hello&quot; , input : &quot; World&quot; , index : 5 , col : 6 , char : ?o } = context In this example we deliberately ensure that the Context ast is not nil iex&gt; alias Ergo . { Context , Parser } iex&gt; import Ergo . { Terminals , Combinators } iex&gt; context = %{ Context . new ( &quot; World&quot; ) | ast : [ ] } iex&gt; parser = optional ( literal ( &quot;Hello&quot; ) ) iex&gt; new_context = Parser . call ( parser , context ) iex&gt; assert % Context { status : :ok , ast : nil , input : &quot; World&quot; , index : 0 , col : 1 , char : 0 } = new_context","ref":"Ergo.Combinators.html#optional/2","title":"Ergo.Combinators.optional/2","type":"function"},{"doc":"","ref":"Ergo.Combinators.html#parse_many/5","title":"Ergo.Combinators.parse_many/5","type":"function"},{"doc":"Examples iex&gt; alias Ergo.Context iex&gt; import Ergo . { Terminals , Combinators } iex&gt; parser = sequence ( [ literal ( &quot;Hello&quot; ) , ws ( ) , literal ( &quot;World&quot; ) ] ) iex&gt; context = Ergo . parse ( parser , &quot;Hello World&quot; ) % Context { status : :ok , ast : [ &quot;Hello&quot; , ?\\s , &quot;World&quot; ] , char : ?d , index : 11 , line : 1 , col : 12 } = context iex&gt; Logger . disable ( self ( ) ) iex&gt; alias Ergo.Context iex&gt; import Ergo . { Terminals , Combinators } iex&gt; parser = sequence ( [ literal ( &quot;Hello&quot; ) , ws ( ) , literal ( &quot;World&quot; ) ] , label : &quot;HelloWorld&quot; ) iex&gt; context = Ergo . parse ( parser , &quot;Hello World&quot; , debug : true ) iex&gt; assert % Context { status : :ok , debug : true , ast : [ &quot;Hello&quot; , ?\\s , &quot;World&quot; ] , char : ?d , index : 11 , line : 1 , col : 12 } = context iex&gt; alias Ergo.Context iex&gt; import Ergo . { Terminals , Combinators } iex&gt; parser = sequence ( [ literal ( &quot;Hello&quot; ) , ws ( ) , literal ( &quot;World&quot; ) ] , map : fn ast -&gt; Enum . join ( ast , &quot; &quot; ) end ) iex&gt; context = Ergo . parse ( parser , &quot;Hello World&quot; ) iex&gt; assert % Context { status : :ok , ast : &quot;Hello 32 World&quot; , char : ?d , index : 11 , line : 1 , col : 12 } = context iex&gt; Logger . disable ( self ( ) ) iex&gt; alias Ergo.Context iex&gt; import Ergo . { Terminals , Combinators } iex&gt; parser = sequence ( [ literal ( &quot;Hello&quot; ) , ws ( ) , literal ( &quot;World&quot; ) ] , label : &quot;HelloWorld&quot; , map : fn ast -&gt; Enum . join ( ast , &quot; &quot; ) end ) iex&gt; context = Ergo . parse ( parser , &quot;Hello World&quot; , debug : true ) iex&gt; assert % Context { status : :ok , debug : true , ast : &quot;Hello 32 World&quot; , char : ?d , index : 11 , line : 1 , col : 12 } = context iex&gt; alias Ergo.Context iex&gt; import Ergo . { Combinators , Terminals } iex&gt; parser = sequence ( [ literal ( &quot;foo&quot; ) , ws ( ) , literal ( &quot;bar&quot; ) ] ) iex&gt; assert % Context { status : { :error , :unexpected_char } } = Ergo . parse ( parser , &quot;Hello World&quot; )","ref":"Ergo.Combinators.html#sequence/2","title":"Ergo.Combinators.sequence/2","type":"function"},{"doc":"The transform/2 parser runs a transforming function on the AST of its child parser. Examples # Sum the digits iex&gt; alias Ergo.Context iex&gt; import Ergo . { Combinators , Terminals } iex&gt; digit_to_int = fn d -&gt; List . to_string ( [ d ] ) |&gt; String . to_integer ( ) end iex&gt; t_fn = fn ast -&gt; ast |&gt; Enum . map ( digit_to_int ) |&gt; Enum . sum ( ) end iex&gt; parser = sequence ( [ digit ( ) , digit ( ) , digit ( ) , digit ( ) ] ) |&gt; transform ( t_fn ) iex&gt; context = Ergo . parse ( parser , &quot;1234&quot; ) iex&gt; % Context { status : :ok , ast : 10 , char : ?4 , index : 4 , line : 1 , col : 5 } = context","ref":"Ergo.Combinators.html#transform/3","title":"Ergo.Combinators.transform/3","type":"function"},{"doc":"Ergo.Context defines the Context record type and functions to create and manipulate them. Fields status When a parser returns it either sets status to :ok to indicate that it was successful or to a tuple {:error, :error_atom} where error_atom is an atom indiciting the specific type of error. It may optionally set the message field to a human readable message. message A human readable version of any error raised. input The binary input being parsed. index Represents the position in the input which has been read so far. Initially 0 it increments for each character processed. line Represents the current line of the input. Initially 1 it increments whenever a is read from the input. col Represents the current column of the input. Initially 1 it is incremented every time a character is read from the input and automatically resets whenever a is read. char Represents the last character read from the input. ast Represents the current data structure being built from the input. debug When set to 'true' parsers will attempt to log their behaviours as they run using the Elixir Logger at the :info level. tracks Parsers for which track: true is specified (by default this is most of the combinator parsers but not the terminal parsers) will add themselves to the Context tracks in the form of {ref, index} . If the same parser attempts to add itself a second time at the same index an error is thrown because a cycle has been detected.","ref":"Ergo.Context.html","title":"Ergo.Context","type":"module"},{"doc":"Because we build ASTs using lists they end up in reverse order. This method reverses the AST back to in-parse-order Examples iex&gt; context = Ergo.Context . new ( ) ...&gt; context = %{ context | ast : [ 4 , 3 , 2 , 1 ] } ...&gt; Context . ast_in_parsed_order ( context ) % Context { ast : [ 1 , 2 , 3 , 4 ] }","ref":"Ergo.Context.html#ast_in_parsed_order/1","title":"Ergo.Context.ast_in_parsed_order/1","type":"function"},{"doc":"Where an AST has been built from individual characters and needs to be converted to a string Examples iex&gt; context = Ergo.Context . new ( ) iex&gt; context = %{ context | ast : [ ?H , ?e , ?l , ?l , ?o ] } iex&gt; Context . ast_to_string ( context ) % Context { ast : &quot;Hello&quot; }","ref":"Ergo.Context.html#ast_to_string/1","title":"Ergo.Context.ast_to_string/1","type":"function"},{"doc":"Called to perform an arbitrary transformation on the AST value of a Context. Examples iex&gt; alias Ergo.Context iex&gt; context = Context . new ( ) iex&gt; context = %{ context | ast : &quot;Hello World&quot; } iex&gt; Context . ast_transform ( context , &amp; Function . identity / 1 ) % Context { ast : &quot;Hello World&quot; } iex&gt; alias Ergo.Context iex&gt; context = Context . new ( ) iex&gt; context = %{ context | ast : &quot;Hello World&quot; } iex&gt; Context . ast_transform ( context , &amp; String . length / 1 ) % Context { ast : 11 } iex&gt; alias Ergo.Context iex&gt; context = Context . new ( ) iex&gt; context = %{ context | ast : &quot;Hello World&quot; } iex&gt; Context . ast_transform ( context , nil ) % Context { ast : &quot;Hello World&quot; }","ref":"Ergo.Context.html#ast_transform/2","title":"Ergo.Context.ast_transform/2","type":"function"},{"doc":"The ignore parser matches but returns a nil for the AST. Parsers like sequence accumulate these nil values. Call this function to remove them Examples iex&gt; context = Ergo.Context . new ( ) ...&gt; context = %{ context | ast : [ &quot;Hello&quot; , nil , &quot;World&quot; , nil ] } ...&gt; Context . ast_without_ignored ( context ) % Context { ast : [ &quot;Hello&quot; , &quot;World&quot; ] }","ref":"Ergo.Context.html#ast_without_ignored/1","title":"Ergo.Context.ast_without_ignored/1","type":"function"},{"doc":"Returns a newly initialised Context with an empty input . Examples iex&gt; Context.new() %Context{}","ref":"Ergo.Context.html#new/0","title":"Ergo.Context.new/0","type":"function"},{"doc":"Returns a newly initialised Context with input set to the string passed in. Examples: iex&gt; Context.new(&quot;Hello World&quot;) %Context{status: :ok, input: &quot;Hello World&quot;, line: 1, col: 1, index: 0, debug: false, tracks: []}","ref":"Ergo.Context.html#new/2","title":"Ergo.Context.new/2","type":"function"},{"doc":"Reads the next character from the input of the passed in Context . If the input is empty returns status: {:error, :unexpected_eoi} . Otherwise returns a new Context setting char to the character read and incrementing positional variables such as index , line , and column appropriately. Examples iex&gt; Context.next_char(Context.new()) %Context{status: {:error, :unexpected_eoi}, message: &quot;Unexpected end of input&quot;} iex&gt; Context.next_char(Context.new(&quot;Hello World&quot;)) %Context{status: :ok, input: &quot;ello World&quot;, char: ?H, ast: ?H, index: 1, line: 1, col: 2}","ref":"Ergo.Context.html#next_char/1","title":"Ergo.Context.next_char/1","type":"function"},{"doc":"Examples iex&gt; context = Context . new ( &quot;Hello&quot; ) ...&gt; Context . peek ( context ) % Context { status : :ok , char : ?H , ast : ?H , input : &quot;ello&quot; , index : 1 , line : 1 , col : 2 } iex&gt; context = Context . new ( ) ...&gt; Context . peek ( context ) % Context { status : { :error , :unexpected_eoi } , message : &quot;Unexpected end of input&quot; , index : 0 , line : 1 , col : 1 }","ref":"Ergo.Context.html#peek/1","title":"Ergo.Context.peek/1","type":"function"},{"doc":"Clears the value of the status and ast fields to ensure that the wrong status information cannot be returned from a child parser. Examples iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; context = %{ context | status : { :error , :inexplicable_error } , ast : true } iex&gt; context = Context . reset_status ( context ) iex&gt; assert % Context { status : :ok , ast : nil } = context","ref":"Ergo.Context.html#reset_status/1","title":"Ergo.Context.reset_status/1","type":"function"},{"doc":"We track which parsers have operated on the input. Examples First example checks that we keep references iex&gt; alias Ergo.Context iex&gt; import Ergo . { Terminals , Combinators } iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; parser = many ( char ( ?H ) ) iex&gt; track = { parser . ref , parser . description , 0 , 1 , 1 } iex&gt; assert % Context { tracks : [ ^ track ] } = context2 = Context . update_tracks ( context , parser . ref , parser . description ) iex&gt; parser2 = many ( char ( ?e ) ) iex&gt; track2 = { parser2 . ref , parser2 . description , 0 , 1 , 1 } iex&gt; assert % Context { tracks : [ ^ track2 , ^ track ] } = Context . update_tracks ( context2 , parser2 . ref , parser2 . description ) Second example checks that we throw if we get a cycle iex&gt; import Ergo . { Terminals , Combinators } iex&gt; parser = many ( choice ( [ many ( ws ( ) ) , char ( ?} ) ] ) ) iex&gt; assert_raise Ergo.Context.CycleError , fn -&gt; Ergo . parse ( parser , &quot;}}}&quot; ) end","ref":"Ergo.Context.html#update_tracks/3","title":"Ergo.Context.update_tracks/3","type":"function"},{"doc":"The Meta parsers are not really parsers at all but operate within the parsing framework. All Meta parsers are combinators that accept a parser and either report on or modify its operation.","ref":"Ergo.Meta.html","title":"Ergo.Meta","type":"module"},{"doc":"The around parser is a pass-thru parser that can be used to run code before or after another parser. For example to inspect the context or output additional debugging information. Specify on of around(parser, before: fn ctx -&gt; … end) around(parser, after: fn ctx, parsed_ctx -&gt; … end) around(parser, before: fn ctx -&gt; … end, after: fn ctx, parsed_ctx -&gt; … end) Note that where both before: and after: are specified, the after function will receive both the context before and after parsing as separate parameters. If neither of before: nor around: are specified an error will be raised. Examples iex&gt; alias Ergo . { Context , Parser } iex&gt; import Ergo.Meta iex&gt; null_parser = Parser . new ( fn % Context { } = ctx -&gt; ctx end ) iex&gt; assert_raise ( RuntimeError , fn -&gt; Ergo . parse ( around ( null_parser ) , &quot;&quot; ) end ) iex&gt; alias Ergo . { Context , Parser } iex&gt; import Ergo.Meta iex&gt; null_parser = Parser . new ( fn % Context { } = ctx -&gt; ctx end ) iex&gt; parser = around ( null_parser , before : fn _ctx -&gt; send ( self ( ) , :before ) end ) iex&gt; Ergo . parse ( parser , &quot;&quot; ) iex&gt; assert_receive :before iex&gt; alias Ergo . { Context , Parser } iex&gt; import Ergo.Meta iex&gt; null_parser = Parser . new ( fn % Context { } = ctx -&gt; ctx end ) iex&gt; parser = around ( null_parser , after : fn _ctx , _new_ctx -&gt; send ( self ( ) , :after ) end ) iex&gt; Ergo . parse ( parser , &quot;&quot; ) iex&gt; assert_receive :after iex&gt; alias Ergo . { Context , Parser } iex&gt; import Ergo.Meta iex&gt; null_parser = Parser . new ( fn % Context { } = ctx -&gt; ctx end ) iex&gt; parser = around ( null_parser , before : fn _ctx -&gt; send ( self ( ) , :before ) end , after : fn _ctx , _new_ctx -&gt; send ( self ( ) , :after ) end ) iex&gt; Ergo . parse ( parser , &quot;&quot; ) iex&gt; assert_receive :before iex&gt; assert_receive :after","ref":"Ergo.Meta.html#around/2","title":"Ergo.Meta.around/2","type":"function"},{"doc":"The failed parser is a combinator that invokes a parser and if the parser fails runs the given function on the resulting context. This can be used to output additional debugging information where failure was unexpected. Examples iex&gt; alias Ergo.Parser iex&gt; import Ergo.Meta iex&gt; failing_parser = Parser . new ( fn ctx -&gt; %{ ctx | status : { :error , :unfathomable_error } } end ) iex&gt; parser = failed ( failing_parser , fn _ctx -&gt; send ( self ( ) , :failed ) end ) iex&gt; Ergo . parse ( parser , &quot;&quot; ) iex&gt; assert_received :failed","ref":"Ergo.Meta.html#failed/2","title":"Ergo.Meta.failed/2","type":"function"},{"doc":"The Parsers module exists to house utility parsers that while they are terminals in the sense that they are not parameterised, they internally make use of parsers from the Combinators module. Parsers uint decimal digits","ref":"Ergo.NumericParsers.html","title":"Ergo.NumericParsers","type":"module"},{"doc":"Examples iex&gt; alias Ergo.Context iex&gt; import Ergo.NumericParsers iex&gt; context = Ergo . parse ( decimal ( ) , &quot;234.56&quot; ) iex&gt; assert % Context { status : :ok , ast : 234.56 } = context","ref":"Ergo.NumericParsers.html#decimal/1","title":"Ergo.NumericParsers.decimal/1","type":"function"},{"doc":"The digits parser matches a series of at least one digit and returns an enumeration of the digits. Examples iex&gt; alias Ergo.Context iex&gt; import Ergo.NumericParsers iex&gt; context = Ergo . parse ( digits ( ) , &quot;2345&quot; ) iex&gt; assert % Context { status : :ok , ast : [ 2 , 3 , 4 , 5 ] } = context","ref":"Ergo.NumericParsers.html#digits/1","title":"Ergo.NumericParsers.digits/1","type":"function"},{"doc":"The number parser matches both integer and decimal string and converts them into their appropriate Elixir integer or float values. Examples iex&gt; import Ergo.NumericParsers iex&gt; assert %{ status : :ok , ast : 42 } = Ergo . parse ( number ( ) , &quot;42&quot; ) iex&gt; import Ergo.NumericParsers iex&gt; assert %{ status : :ok , ast : - 42 } = Ergo . parse ( number ( ) , &quot;-42&quot; ) iex&gt; import Ergo.NumericParsers iex&gt; assert %{ status : :ok , ast : 42.0 } = Ergo . parse ( number ( ) , &quot;42.0&quot; ) iex&gt; import Ergo.NumericParsers iex&gt; assert %{ status : :ok , ast : - 42.0 } = Ergo . parse ( number ( ) , &quot;-42.0&quot; ) iex&gt; import Ergo.NumericParsers iex&gt; assert %{ status : :ok , ast : 0 } = Ergo . parse ( number ( ) , &quot;0&quot; ) iex&gt; import Ergo.NumericParsers iex&gt; assert %{ status : :ok , ast : 0 } = Ergo . parse ( number ( ) , &quot;0000&quot; ) iex&gt; import Ergo.NumericParsers iex&gt; assert %{ status : { :error , _ } } = Ergo . parse ( number ( ) , &quot;Fourty Two&quot; ) iex&gt; import Ergo.NumericParsers iex&gt; assert %{ status : :ok , ast : 42 } = Ergo . parse ( number ( ) , &quot;42Fourty Two&quot; )","ref":"Ergo.NumericParsers.html#number/1","title":"Ergo.NumericParsers.number/1","type":"function"},{"doc":"The unit parser matches a series of at least one digit and returns the integer value of the digits. Examples iex&gt; alias Ergo.Context iex&gt; import Ergo.NumericParsers iex&gt; context = Ergo . parse ( uint ( ) , &quot;2345&quot; ) iex&gt; assert % Context { status : :ok , ast : 2345 , char : ?5 , index : 4 , col : 5 } = context","ref":"Ergo.NumericParsers.html#uint/1","title":"Ergo.NumericParsers.uint/1","type":"function"},{"doc":"Ergo.Parser contains the Parser record type. Ergo parsers are anonymous functions but we embed them in a Parser record that can hold arbitrary metadata. The primary use for the metadata is the storage of debugging information.","ref":"Ergo.Parser.html","title":"Ergo.Parser","type":"module"},{"doc":"call/2 invokes the specified parser by calling its parsing function with the specified context having first reset the context status.","ref":"Ergo.Parser.html#call/2","title":"Ergo.Parser.call/2","type":"function"},{"doc":"description/1 returns the description metadata for the parser. Examples iex&gt; parser = Parser . new ( identity , %{ description : &quot;Not a parser at all&quot; } ) iex&gt; Ergo.Parser . description ( parser ) &quot;Not a parser at all&quot;","ref":"Ergo.Parser.html#description/1","title":"Ergo.Parser.description/1","type":"function"},{"doc":"new/2 creates a new Parser from the given parsing function and with the specified metadata.","ref":"Ergo.Parser.html#new/2","title":"Ergo.Parser.new/2","type":"function"},{"doc":"Ergo.Terminals contains the terminal parsers. A terminal parser is a parser that is not parameterised with another parser and works directly with the input. Parsers eoi char digit alpha ws wc literal","ref":"Ergo.Terminals.html","title":"Ergo.Terminals","type":"module"},{"doc":"The alpha/0 parser accepts a single character in the range a..z or A..Z. Examples iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = alpha ( ) iex&gt; Ergo . parse ( parser , &quot;Hello World&quot; ) % Context { status : :ok , input : &quot;ello World&quot; , char : ?H , ast : ?H , index : 1 , line : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = alpha ( ) iex&gt; Ergo . parse ( parser , &quot;ello World&quot; ) % Context { status : :ok , input : &quot;llo World&quot; , char : ?e , ast : ?e , index : 1 , line : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = alpha ( ) iex&gt; Ergo . parse ( parser , &quot; World&quot; ) % Context { status : { :error , :unexpected_char } , message : &quot;Expected: [a..z, A..Z] Actual: &quot; , input : &quot; World&quot; }","ref":"Ergo.Terminals.html#alpha/0","title":"Ergo.Terminals.alpha/0","type":"function"},{"doc":"The char/1 parser is a terminal parser that matches a specific character. Examples iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = char ( ?H ) iex&gt; Ergo . parse ( parser , &quot;Hello World&quot; ) % Context { status : :ok , char : ?H , ast : ?H , input : &quot;ello World&quot; , index : 1 , line : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = char ( ?h ) iex&gt; Ergo . parse ( parser , &quot;Hello World&quot; ) % Context { status : { :error , :unexpected_char } , message : &quot;Expected: h Actual: H&quot; , input : &quot;Hello World&quot; } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = char ( ?H ) iex&gt; Ergo . parse ( parser , &quot;&quot; ) % Context { status : { :error , :unexpected_eoi } , message : &quot;Unexpected end of input&quot; } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = char ( ?A .. ?Z ) iex&gt; Ergo . parse ( parser , &quot;Hello World&quot; ) % Context { status : :ok , char : ?H , ast : ?H , input : &quot;ello World&quot; , index : 1 , line : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = char ( ?a .. ?z ) iex&gt; Ergo . parse ( parser , &quot;Hello World&quot; ) % Context { status : { :error , :unexpected_char } , message : &quot;Expected: a..z Actual: H&quot; , input : &quot;Hello World&quot; } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = char ( ?A .. ?Z ) iex&gt; Ergo . parse ( parser , &quot;&quot; ) % Context { status : { :error , :unexpected_eoi } , message : &quot;Unexpected end of input&quot; } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = char ( [ ?a .. ?z , ?A .. ?Z ] ) iex&gt; Ergo . parse ( parser , &quot;Hello World&quot; ) % Context { status : :ok , char : ?H , ast : ?H , input : &quot;ello World&quot; , index : 1 , line : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = char ( [ ?a .. ?z , ?A .. ?Z ] ) iex&gt; Ergo . parse ( parser , &quot;0000&quot; ) % Context { status : { :error , :unexpected_char } , message : &quot;Expected: [a..z, A..Z] Actual: 0&quot; , input : &quot;0000&quot; } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = char ( - ?0 ) iex&gt; Ergo . parse ( parser , &quot;0000&quot; ) % Context { status : { :error , :unexpected_char } , message : &quot;Should not have matched 0&quot; , input : &quot;0000&quot; } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = char ( - ?a ) iex&gt; Ergo . parse ( parser , &quot;0000&quot; ) % Context { status : :ok , input : &quot;000&quot; , ast : ?0 , char : ?0 , index : 1 , col : 2 }","ref":"Ergo.Terminals.html#char/1","title":"Ergo.Terminals.char/1","type":"function"},{"doc":"The digit/0 parser accepts a character in the range of 0..9 Examples iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = digit ( ) iex&gt; Ergo . parse ( parser , &quot;0000&quot; ) % Context { status : :ok , char : ?0 , ast : ?0 , input : &quot;000&quot; , index : 1 , line : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; import Ergo.Terminals iex&gt; parser = digit ( ) iex&gt; Ergo . parse ( parser , &quot;AAAA&quot; ) % Context { status : { :error , :unexpected_char } , message : &quot;Expected: 0..9 Actual: A&quot; , char : 0 , input : &quot;AAAA&quot; , index : 0 , line : 1 , col : 1 } iex&gt; alias Ergo . { Context , Parser } iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( ) iex&gt; parser = digit ( ) iex&gt; Parser . call ( parser , context ) % Context { status : { :error , :unexpected_eoi } , message : &quot;Unexpected end of input&quot; , char : 0 , input : &quot;&quot; , index : 0 , line : 1 , col : 1 }","ref":"Ergo.Terminals.html#digit/0","title":"Ergo.Terminals.digit/0","type":"function"},{"doc":"The eoi parser is a terminal parser that checks whether the input has been fully consumed. If there is input remaining to be parsed the return context status is set to :error. Examples iex&gt; alias Ergo . { Context , Parser } iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( ) iex&gt; Parser . call ( eoi ( ) , context ) % Context { status : :ok , ast : nil } iex&gt; alias Ergo . { Context , Parser } iex&gt; import Ergo.Terminals iex&gt; context = Context . new ( &quot;Hello World&quot; ) iex&gt; Parser . call ( eoi ( ) , context ) % Context { status : { :error , :not_eoi } , message : &quot;Input not empty: Hello World…&quot; , input : &quot;Hello World&quot; }","ref":"Ergo.Terminals.html#eoi/0","title":"Ergo.Terminals.eoi/0","type":"function"},{"doc":"The literal/1 parser matches the specified string character by character. Examples iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = literal ( &quot;Hello&quot; ) iex&gt; Ergo . parse ( parser , &quot;Hello World&quot; ) % Context { status : :ok , input : &quot; World&quot; , ast : &quot;Hello&quot; , char : ?o , index : 5 , line : 1 , col : 6 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = literal ( &quot;Hellx&quot; ) iex&gt; Ergo . parse ( parser , &quot;Hello World&quot; ) % Context { status : { :error , :unexpected_char } , message : &quot;Expected: x Actual: o [in literal \\&quot; Hellx \\&quot; ]&quot; , input : &quot;o World&quot; , ast : [ ?l , ?l , ?e , ?H ] , char : ?l , index : 4 , line : 1 , col : 5 }","ref":"Ergo.Terminals.html#literal/2","title":"Ergo.Terminals.literal/2","type":"function"},{"doc":"The wc/0 parser parses a word character and is analagous to the \\w regular expression. Examples iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = wc ( ) iex&gt; Ergo . parse ( parser , &quot;Hello World&quot; ) % Context { status : :ok , char : ?H , ast : ?H , input : &quot;ello World&quot; , index : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = wc ( ) iex&gt; Ergo . parse ( parser , &quot;0 World&quot; ) % Context { status : :ok , char : ?0 , ast : ?0 , input : &quot; World&quot; , index : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = wc ( ) iex&gt; Ergo . parse ( parser , &quot;_Hello&quot; ) % Context { status : :ok , char : ?_ , ast : ?_ , input : &quot;Hello&quot; , index : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = wc ( ) iex&gt; Ergo . parse ( parser , &quot; Hello&quot; ) % Context { status : { :error , :unexpected_char } , message : &quot;Expected: [0..9, a..z, A..Z, _] Actual: &quot; , input : &quot; Hello&quot; }","ref":"Ergo.Terminals.html#wc/0","title":"Ergo.Terminals.wc/0","type":"function"},{"doc":"The ws/0 parser accepts a white space character and is equivalent to the \\s regular expression. Examples iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = ws ( ) iex&gt; Ergo . parse ( parser , &quot; World&quot; ) % Context { status : :ok , char : ?\\s , ast : ?\\s , input : &quot;World&quot; , index : 1 , line : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = ws ( ) iex&gt; Ergo . parse ( parser , &quot; \\t World&quot; ) % Context { status : :ok , char : ?\\t , ast : ?\\t , input : &quot;World&quot; , index : 1 , line : 1 , col : 2 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = ws ( ) iex&gt; Ergo . parse ( parser , &quot; \\n World&quot; ) % Context { status : :ok , char : ?\\n , ast : ?\\n , input : &quot;World&quot; , index : 1 , line : 2 , col : 1 } iex&gt; alias Ergo.Context iex&gt; import Ergo.Terminals iex&gt; parser = ws ( ) iex&gt; Ergo . parse ( parser , &quot;Hello World&quot; ) % Context { status : { :error , :unexpected_char } , message : &quot;Expected: [ \\s , \\t , \\r , \\n , \\v ] Actual: H&quot; , input : &quot;Hello World&quot; }","ref":"Ergo.Terminals.html#ws/0","title":"Ergo.Terminals.ws/0","type":"function"},{"doc":"","ref":"Ergo.Utils.html","title":"Ergo.Utils","type":"module"},{"doc":"Examples iex&gt; Ergo.Utils . char_to_string ( ?H ) &quot;H&quot; iex&gt; Ergo.Utils . char_to_string ( ?h ) &quot;h&quot;","ref":"Ergo.Utils.html#char_to_string/1","title":"Ergo.Utils.char_to_string/1","type":"function"},{"doc":"If the string str is longer than max (default: 40) it is truncated to 37 chars and &quot;...&quot; is added to the end, otherwise it is returned unaltered. Examples iex&gt; Ergo.Utils . ellipsize ( &quot;frob&quot; ) &quot;frob&quot; iex&gt; Ergo.Utils . ellipsize ( &quot;123456789012345678901234567890123456789012345678901&quot; ) &quot;1234567890123456789012345678901234567...&quot; iex&gt; Ergo.Utils . ellipsize ( &quot;12345678901234567890&quot; , 10 ) &quot;1234567...&quot; iex&gt; Ergo.Utils . ellipsize ( &quot;12345&quot; , 4 ) &quot;1...&quot;","ref":"Ergo.Utils.html#ellipsize/2","title":"Ergo.Utils.ellipsize/2","type":"function"},{"doc":"","ref":"Ergo.Context.CycleError.html","title":"Ergo.Context.CycleError","type":"exception"}]